/**
* ...
* @author Dani Llops
* @version 0.1
*/

package{
	import flash.display.*;
	import flash.events.*;
	import flash.geom.ColorTransform;
	import Pixel;
	
	public class Main extends Sprite
	{		
		// MC en el escenario
		public var marco_mc:MovieClip;
		
		// Medidas escenario
		public static var ANCHO:int = 300;
		public static var ALTO:int = 250;
		
		// Color
		public static var AMARILLO:uint = 0xFFFFFF00;
		
		// Bitmap
		private var _bmpData:BitmapData = new BitmapData(ANCHO, ALTO, true, 0);
		private var _bmp:Bitmap = new Bitmap(_bmpData);
		
		// Variables
		private var _cont:int = 0;
		private var _init:Boolean = false;
		private var _pixels:Array = new Array();
		private var _ct:ColorTransform = new ColorTransform();
		
		function Main() 
		{
			// Aadir el bitmap
			addChild(_bmp);
			
			// Poner el marco por encima de todo
			addChild(marco_mc);
			
			// Eventos
			stage.addEventListener(MouseEvent.CLICK, crearPixels);
			stage.addEventListener(Event.ENTER_FRAME, render);
			
			// Indicamos el nivel de alpha
			_ct.alphaMultiplier = .9;
			
			// Iniciamos la aplicacin
			_init = true;
		}
		
		private function crearPixels(e:MouseEvent):void 
		{	
			// Crear 50 pixels y aadirlos al array
			for (var i:int = 0; i < 50; i++)
			{
				_pixels.unshift(new Pixel(_cont, mouseX, mouseY));
				_cont++;
			}
		}
		
		private function render(e:Event):void 
		{
			if (_init)
			{
				// Recorremos el array de pixels
				for (var a:String in _pixels) 
				{
					// Cogemos cada pixel
					var p:Pixel = _pixels[a];
					
					// Pintamos en el bitmap, en la posiciones
					// de nuestro pixel
					_bmpData.setPixel32(p.x, p.y, AMARILLO);
					p.mover();
					
					// Si el pixel se sale del escenario, eliminarlo
					if (p.y > ALTO) eliminarPixel(p);
				}
				
				// Aplicamos el colorTransform con alpha
				// para conseguir el efecto de FADE
				_bmpData.colorTransform(_bmpData.rect, _ct);
			}
		}
		
		// Funcion para eliminar los pixels que no se necesitan
		// Se recorre el array y se busca el pixel que se desea
		// eliminar sacndolo del array
		private function eliminarPixel(p:Pixel):void
		{
			var long:int = _pixels.length;
			for (var i:int = 0; i < long; i++) 
			{
				if (p == _pixels[i])
				{
					//trace("Eliminar", p.name);
					_pixels.splice(i, 1);
				}
			}
		}
	}
}